#include<bits/stdc++.h>
#include<math.h>
#define ull unsigned long long
using namespace std;


int main()
{
    
    int h,n;
    cin>>h>>n;
    bool mat[h+1][n];

    for(int i=1;i<=h;i++){
    for(int j=0;j<n;j++){
        cin>>mat[i][j];
    }
    }
    int vodopad[h+1][n];
    memset(vodopad,0,sizeof(vodopad));
    for(int i=0;i<n;i++)
        {vodopad[0][i]=1;
          mat[0][i]=1;
        }
    int red=0;
    while(red<h){
        for(int kolona=0;kolona<n;kolona++){
            if(mat[red][kolona]){
                if(mat[red+1][kolona]){
                    //ispod nije kamen
                    vodopad[red+1][kolona]+=vodopad[red][kolona];
                }
                else{
                    int kamenjel=kolona-1,kamenjed=kolona+1;
                    while(kamenjel>0&&!mat[red+1][kamenjel])kamenjel--;
                    while(kamenjed<n-1&&!mat[red+1][kamenjed])kamenjed++;
                    if(kamenjel<0){
                        //ide do leve ivice
                        vodopad[red+1][kamenjed]+=vodopad[red][kolona];
                    }
                    else if(kamenjed>n-1){
                        //ide do desne ivice
                        vodopad[red+1][kamenjel]+=vodopad[red][kolona];
                    }
                    else{
                        //otvoreno sa obe strane
                        int str=vodopad[red][kolona]/2;
                            //jednako se deli
                            vodopad[red+1][kamenjed]+=str;
                            vodopad[red+1][kamenjel]+=str;

                        if(vodopad[red][kolona]%2==1){
                            if((red+1)%2==1){
                                //vise na levu
                                vodopad[red+1][kamenjel]+=1;
                            }
                            else{
                                //vise na desnu
                                vodopad[red+1][kamenjed]+=1;
                            }
                        }
                    }
                }
            }
        }
        red++;
    }
    /*for(int i=0;i<=h;i++){*/
        for(int j=0;j<n;j++){
        cout<<vodopad[h][j]<<" ";
    /*}
    cout<<endl;*/
    }
    
    return 0;
}